  ; Layout: 4-plane planar.  Each pixel color is determined by the combined
          ; value of bits in the four color planes.  Each color plane begins
          ; at a000:0.  To select a plane, use:

            ; OUT 3ceH, 0005H         ;set up for plane masking
            ; OUT 3c4H, n             ;n is: 0102H=plane 0; 0202H=plane 1
                                    ; ;      0402H=plane 2; 0802H=plane 3
            ; ...(write video data)...
            ; OUT 3c4H, 0f02H         ;restore normal plane mask


GetScreenPos:	;BH,BL = X,Y	Returns ES:DI=Destination
	push bx
	push ax
		xor ax,ax
		mov al,bh
		mov di,ax
		xor ax,ax
		mov al,bl
		mov bx,40
		mul bx
		add di,ax
		mov ax,0B800h 
		mov es,ax
	pop ax
	pop bx
	ret
	

GetScreenNextLine:
	push ax
		mov ax,di
		and ax,2000h
		mov ax,di
		jz GetScreenNextLineDone
		add ax,80	
GetScreenNextLineDone:	
		xor ax,2000h
		mov di,ax
	pop ax
	ret

ScreenInit:
	mov     ah, 0           ; int 10,0
    mov     al, 4           ; mode 4 (cga 320x200 4 color)
    int     10h             ; bios int
	
	
	mov     ah, 0Bh         ; interrupt 10B
	mov     bh, 1           ; 1 = 4 pallette mode
	mov     bl, 1           ; 0 = warm colors (r,g,b) 1 = cool (c,m,w)
	int     10h             ; bios int

	mov ah, 0Bh
;;	xor bx, bx          ; low intensity, black background
	mov bx, 0010h       ; high intensity
	int 10h

	ret

PrintChar:
	push si
	push di
	push es
	push ds
	push dx
	push cx
	push bx
	push ax
		push ds
			push ax
				
			;	call domonitor
				
				mov ax,0
				mov al,[ds:CursorY]
				mov bx,40*8
				mul bx
				mov di,ax
				
				mov ax,0
				mov al,[ds:CursorX]
				rcl ax,1
				add di,ax
			
					mov si,offset BitmapFont
					
					mov ax, seg BitmapFont
					mov ds, ax
			pop ax
			sub al,32
			mov ah,0
			mov cl,3
			rcl ax,cl
			add si,ax
			
			mov cx,4
			push es
			
				mov ax,0B800h 
				mov es,ax
		FontAgain:	
				push cx
					Call PrintCharDoPair
					
					add di,2000h
					Call PrintCharDoPair
					sub di,2000h
					add di,80
				pop cx
				dec cx
				jnz FontAgain
			pop es
			
		pop ds
		;inc [ds:CursorX]
		inc [ds:CursorX]
		cmp [ds:CursorX],40
		jne PrintCharNoNewLine
		call NewLine
PrintCharNoNewLine:
	pop ax
	pop bx
	pop cx
	pop dx
	pop ds
	pop es
	pop di
	pop si
	ret

	
PrintCharDoPair:
	mov al,[ds:si]
	
	mov cl,2	;For RCL
	
	Call PrintCharDoOne
	inc di
	Call PrintCharDoOne
	inc si
	dec di
	ret

PrintCharDoOne:	
	mov ah,0
	rcl al,1
	rcl ah,cl
	rcl al,1
	rcl ah,cl
	rcl al,1
	rcl ah,cl
	rcl al,1
	rcl ah,1
	mov bh,ah
	rcl ah,1
	or ah,bh
	;and ah,[FontColor]
	mov es:[di],ah
	ret
	
Locate:
		mov [ds:CursorX],bh
		mov [ds:CursorY],bl
	ret
NewLine:
		mov [ds:CursorX],0
		inc [ds:CursorY]
	ret
	
PrintSpace:
	push ax
		mov al,' '
		call PrintChar
	pop ax
	ret
	
SetPalette:

	
	; mov     ah, 0Bh         ; interrupt 10B
    ; mov     bh, 1           ; 1 = 4 pallette mode
    ; mov     bl, 1           ; 0 = warm colors (r,g,b) 1 = cool (c,m,w)
    ; int     10h             ; bios int
	
	; mov ah, 0Bh
	; xor bx, bx          ; low intensity, black background
    ; int 10h
	
	; mov ah, 0Bh
    ; mov bx, 0010h       ; high intensity
    ;int 10h
ret